<?php
namespace Geral\Repositories;

use \Setforms2\Shared\Registry;

class Banco extends \Doctrine\ORM\EntityRepository
{
    public static function getBanco($cdreducont){
        try {
            $sql = "SELECT CONTCORR.CDBANCO, CONTCORR.CDAGENCIA, CONTCORR.CDCONTCORR,
                           CONTCORR.DSCONTCORR, CONTCORR.CDREDUCONT, BANCO.NMBANCO
                      FROM CONTCORR, BANCO
                     WHERE(CONTCORR.CDREDUCONT = :P_CDREDUCONT) AND
                               (CONTCORR.CDBANCO = BANCO.CDBANCO)
                     ORDER BY CONTCORR.CDBANCO, CONTCORR.CDAGENCIA, CONTCORR.CDCONTCORR";

            $paramsWhere = array('P_CDREDUCONT'   => $cdreducont);

            return Registry::getEntityManager()->getConnection()->fetchColumn($sql, $paramsWhere);
        }catch (\Exception $e)
        {
            throw $e;
        }
    }
	
	public function getNossoNumero($contador){
        $sql = <<<SQL
              SELECT NRSEQUENCIAL + 1 AS NRSEQUENCIAL
                FROM NOVOCODIGO
               WHERE CDCONTADOR = :P_CONTADOR
SQL;
        $params = array('P_CONTADOR' => $contador);

        return $this->getEntityManager()->getConnection()->fetchAll($sql, $params);
    }

    public function updateNossoNumero($contador, $nossoNumero){
        $sql = <<<SQL
               UPDATE NOVOCODIGO
                  SET NRSEQUENCIAL = :P_NOSSONUMERO - 1
                WHERE CDCONTADOR = :P_CONTADOR
SQL;
        $params  = array(
            "P_NOSSONUMERO" => $nossoNumero,
            "P_CONTADOR"    => $contador
        );

        $this->getEntityManager()->getConnection()->executeQuery($sql, $params);

    }
}