package com.javaseleniumtemplate.pages;
import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.WebElement;

public class LoginPage extends PageBase {
    //Mapping   
    By usernameField = By.xpath("//*[@id='USER']");
    By passwordField = By.xpath("//*[@id='PASSWORD']");
    By loginButton = By.xpath("//*[@id='SUBMIT']");
    By mensagemErroTextArea = By.xpath("//*[@class='zh-text-alert']");
    By mensagemAlert = By.xpath("//*[@class='zh-alert-button horizontal'][1]");
    By mensagemAlert2 = By.xpath("//*[@class='zh-alert-button']");
    By loadingWait = By.xpath("//*[@class='zh-background-loading ng-scope']//span[@class='zh-loading-icon']");

    //Parametros de Login:
    public void preenhcerUsuario(String usuario){
        waitForVisibilityOfElementLocated(usernameField);
        click(usernameField);
        sendKeys(usernameField, usuario);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void preencherSenha(String senha){
        waitForVisibilityOfElementLocated(passwordField);
        click(passwordField);
        sendKeys(passwordField, senha);
        waitForInvisibilityOfElementLocated(loadingWait);

    }
    public void clicarEmLogin(){
        waitForVisibilityOfElementLocated(loginButton);
        click(loginButton);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void aceitarMensagemAlerta(){
        waitForVisibilityOfElementLocated(mensagemErroTextArea);
        waitForVisibilityOfElementLocated(mensagemAlert);
        click(mensagemAlert);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    public void aceitarMensagemAlerta2(){
        click(mensagemAlert2);
    }
    public String retornaMensagemDeErro(){
        return getText(mensagemErroTextArea);
    }

}
